import os
import shutil
import subprocess
from dh_agent import settings


def run(context):

    git_cmd_log = context['log_dir'] + '/git.log'
    build_cmd_log = context['log_dir'] + '/build.log'

    git_cmd = [
        'git',
        'pull',
        'origin', 'emop'
    ]

    with open(git_cmd_log, 'w') as fout:
        subprocess.call(git_cmd, cwd=settings.OCULAR_UPDATE_ROOT, stdout=fout)

    proc_signature = context['job_signature'] + 'p1'
    slurm_file_path = context['slurm_dir'] + '/' + proc_signature + '.slrm'

    slurm_file = SLURM_PREFIX
    slurm_file += "cd " + settings.OCULAR_UPDATE_ROOT + "\n"
    slurm_file += './make_jar.sh' + "\n"

    with open(slurm_file_path, 'w') as fout:
        fout.write(slurm_file)

    command = [
        "sbatch", "--parsable",
        "-p", settings.SLURM_QUEUE,
        "-J", proc_signature,
        "-o", build_cmd_log,
        "--mem-per-cpu", str(settings.SLURM_MEMORY_PER_CPU),
        "--cpus-per-task", str(SLURM_CPUS_PER_TASK),
        "--time", "5",
        slurm_file_path
    ]

    subprocess.call(command)


SLURM_PREFIX = '''#!/bin/bash
#SBATCH --nodes=1
#SBATCH --ntasks=1
#SBATCH --signal=USR1@300

module load java/1.8.0_77
export _JAVA_OPTIONS=-Xmx512M

'''

SLURM_CPUS_PER_TASK = 2